# coding: utf-8

"""
    BIMData API

    BIMData API is a tool to interact with your models stored on BIMData’s servers.     Through the API, you can manage your projects, the clouds, upload your IFC files and manage them through endpoints.  # noqa: E501

    The version of the OpenAPI document: v1
    Contact: support@bimdata.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from bimdata_api_client.configuration import Configuration


class StoreyRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'elevation': 'float',
        'is_site': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'elevation': 'elevation',
        'is_site': 'is_site'
    }

    def __init__(self, id=None, name=None, elevation=None, is_site=None, local_vars_configuration=None):  # noqa: E501
        """StoreyRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._elevation = None
        self._is_site = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.name = name
        self.elevation = elevation
        if is_site is not None:
            self.is_site = is_site

    @property
    def id(self):
        """Gets the id of this StoreyRequest.  # noqa: E501


        :return: The id of this StoreyRequest.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this StoreyRequest.


        :param id: The id of this StoreyRequest.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this StoreyRequest.  # noqa: E501


        :return: The name of this StoreyRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this StoreyRequest.


        :param name: The name of this StoreyRequest.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) > 256):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `256`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def elevation(self):
        """Gets the elevation of this StoreyRequest.  # noqa: E501


        :return: The elevation of this StoreyRequest.  # noqa: E501
        :rtype: float
        """
        return self._elevation

    @elevation.setter
    def elevation(self, elevation):
        """Sets the elevation of this StoreyRequest.


        :param elevation: The elevation of this StoreyRequest.  # noqa: E501
        :type: float
        """

        self._elevation = elevation

    @property
    def is_site(self):
        """Gets the is_site of this StoreyRequest.  # noqa: E501


        :return: The is_site of this StoreyRequest.  # noqa: E501
        :rtype: bool
        """
        return self._is_site

    @is_site.setter
    def is_site(self, is_site):
        """Sets the is_site of this StoreyRequest.


        :param is_site: The is_site of this StoreyRequest.  # noqa: E501
        :type: bool
        """

        self._is_site = is_site

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StoreyRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StoreyRequest):
            return True

        return self.to_dict() != other.to_dict()
